/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef CFGFILE_HPP
#define CFGFILE_HPP

#include <map>
#include <string>
#include <vector>

class CfgFile {
    public:
        enum file_formats {
            UNK_FORMAT,
            XML
        };

        enum versions {
            UNK_VERSION,
            BASE_VERSION
        };

        static const std::map<std::string, file_formats> str_extensions;

        CfgFile(std::string _file_path, file_formats _format);
        std::string get_file_path();
        file_formats get_format();
        std::string get_format_str();
        virtual int get_version() = 0;
        std::string get_version_str();

        virtual std::map< std::string, std::vector<std::string> >
            get_logical_groups() = 0;
        virtual std::vector<std::string>
            get_logical_group(std::string name) = 0;

        virtual ~CfgFile();

    protected:
        virtual std::map<std::string, int> get_str_versions() = 0;
    private:
        const file_formats format;
        const std::string file_path;
};

#endif /* CFGFILE_HPP */