/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef CFGFILEFCTRY_HPP
#define CFGFILEFCTRY_HPP

#include "CfgFile.hpp"
#include <string>
#include <map>
#include <memory>

class CfgFileFctry {
    public:
        static const std::map< CfgFile::file_formats,
            std::map<int, std::shared_ptr<CfgFile>(*)(std::string)> >
            formats_versions;

        CfgFileFctry();
        std::shared_ptr<CfgFile> get_cfg_obj(std::string file_path);
        std::shared_ptr<CfgFile> auto_file_format(std::string file_path);
        CfgFile::file_formats get_file_format(std::string file_path);
        virtual ~CfgFileFctry();
};

#endif /* CFGFILEFCTRY_HPP */