/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef CFGFILE_ERROR_HPP
#define CFGFILE_ERROR_HPP

#include <stdexcept>
#include <stdarg.h>
#include <string>

class CfgFile_Error : public std::runtime_error {
    public:
        enum errors{
            UNABLE_OPEN,
            UNK_FORMAT
        };

        std::string message;
        errors error_no;

        CfgFile_Error(errors error_no, ...);
        CfgFile_Error(const CfgFile_Error& obj);
        virtual const char* what() const throw();
        virtual ~CfgFile_Error() throw();

    private:
        void assemble_error(va_list args);
};

#endif /* CFGFILE_ERROR_HPP */