/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef PARSETOOLS_ERROR_HPP
#define PARSETOOLS_ERROR_HPP

#include <stdexcept>
#include <stdarg.h>
#include <string>

class ParseTools_Error : public std::runtime_error {
    public:
        enum errors{
            BAD_REGEX
        };

        std::string message;
        errors error_no;

        ParseTools_Error(errors error_no, ...);
        ParseTools_Error(const ParseTools_Error& obj);
        virtual const char* what() const throw();
        virtual ~ParseTools_Error() throw();

    private:
        void assemble_error(va_list args);
};

#endif /* PARSETOOLS_ERROR_HPP */