/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef CFGXML_ERROR_HPP
#define CFGXML_ERROR_HPP

#include <stdexcept>
#include <stdarg.h>
#include <string>

class CfgXML_Error : public std::runtime_error {
    public:
        enum errors{
            UNABLE_OPEN,
            MISSING_ATTR,
            MISSING_TAG
        };

        std::string message;
        errors error_no;

        CfgXML_Error(errors error_no, ...);
        CfgXML_Error(const CfgXML_Error& obj);
        virtual const char* what() const throw();
        virtual ~CfgXML_Error() throw();

    private:
        void assemble_error(va_list args);
};

#endif	/* CFGXML_ERROR_HPP */