/*
 * Copyright (c) 2017      Intel Corporation. All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#ifndef LOGICALGROUP_HPP
#define LOGICALGROUP_HPP

#include "../parsers/CfgFile.hpp"
#include "RangeListStr.hpp"
#include <map>
#include <memory>
#include <string>
#include <regex.h>
#include <vector>

class LogicalGroup {
    public:
        static const std::string str_rgx_split;
        static const std::string str_rgx_group;

        LogicalGroup();
        void load_from(std::shared_ptr<CfgFile> cfg);
        void clean_groups();
        std::vector<std::string> expand(std::string list_s);
        bool in_list(std::string element, std::string list);
        virtual ~LogicalGroup();

    private:
        regex_t rgx_group;
        std::map< std::string, std::vector<std::string> > groups;
        std::vector<RangeListStr> log_grp;
        std::vector<RangeListStr> log_list;

        void load_cfgi(std::string cfgiPath);
        void expand_element(std::string element,
                            std::vector<std::string>& to_expand,
                            std::vector<std::string>& expanded);
        void expand_groups(std::vector<std::string>& expanded,
                           std::vector<std::string>& to_expand,
                           std::vector<std::string>& expanded_grps);
        bool check_log(RangeListStr& list, std::vector<RangeListStr>& log);
        bool element_in_list(std::string s_element, std::string s_list);
        bool element_in_groups(RangeListStr& element,
                               std::vector<std::string>& to_expand,
                               std::vector<std::string>& expanded_grps);
        bool group2expand(std::string element,
                          std::vector<std::string>& to_expand);
};

#endif /* LOGICALGROUP_HPP */